import { BlockStates } from "@minecraft/server";
import { clear } from "./display";
export const blocks = {
    "minecraft:oak_planks": {
        lang: "tile.planks.oak.name",
    },
    "minecraft:spruce_planks": {
        lang: "tile.planks.spruce.name",
    },
    "minecraft:birch_planks": {
        lang: "tile.planks.birch.name",
    },
    "minecraft:jungle_planks": {
        lang: "tile.planks.jungle.name",
    },
    "minecraft:acacia_planks": {
        lang: "tile.planks.acacia.name",
    },
    "minecraft:dark_oak_planks": {
        lang: "tile.planks.big_oak.name",
    },
    "minecraft:mangrove_planks": {
        lang: "tile.mangrove_planks.name",
    },
    "minecraft:cherry_planks": {
        lang: "tile.cherry_planks.name",
    },
    "minecraft:bamboo_planks": {
        lang: "tile.bamboo_planks.name",
    },
    "minecraft:bamboo_mosaic": {
        lang: "tile.bamboo_mosaic.name",
    },
    "minecraft:crimson_planks": {
        lang: "tile.crimson_planks.name",
    },
    "minecraft:warped_planks": {
        lang: "tile.warped_planks.name",
    },
    "minecraft:cobblestone_wall": {
        lang: "tile.cobblestone_wall.normal.name",
    },
    "minecraft:mossy_cobblestone_wall": {
        lang: "tile.cobblestone_wall.mossy.name",
    },
    "minecraft:granite_wall": {
        lang: "tile.cobblestone_wall.granite.name",
    },
    "minecraft:diorite_wall": {
        lang: "tile.cobblestone_wall.diorite.name",
    },
    "minecraft:andesite_wall": {
        lang: "tile.cobblestone_wall.andesite.name",
    },
    "minecraft:sandstone_wall": {
        lang: "tile.cobblestone_wall.sandstone.name",
    },
    "minecraft:red_sandstone_wall": {
        lang: "tile.cobblestone_wall.red_sandstone.name",
    },
    "minecraft:stone_brick_wall": {
        lang: "tile.cobblestone_wall.stone_brick.name",
    },
    "minecraft:mossy_stone_brick_wall": {
        lang: "tile.cobblestone_wall.mossy_stone_brick.name",
    },
    "minecraft:brick_wall": {
        lang: "tile.cobblestone_wall.brick.name",
    },
    "minecraft:nether_brick_wall": {
        lang: "tile.cobblestone_wall.nether_brick.name",
    },
    "minecraft:red_nether_brick_wall": {
        lang: "tile.cobblestone_wall.red_nether_brick.name",
    },
    "minecraft:end_stone_brick_wall": {
        lang: "tile.cobblestone_wall.end_brick.name",
    },
    "minecraft:prismarine_wall": {
        lang: "tile.cobblestone_wall.prismarine.name",
    },
    "minecraft:blackstone_wall": {
        lang: "tile.blackstone_wall.name",
    },
    "minecraft:polished_blackstone_wall": {
        lang: "tile.polished_blackstone_wall.name",
    },
    "minecraft:polished_blackstone_brick_wall": {
        lang: "tile.polished_blackstone_brick_wall.name",
    },
    "minecraft:cobbled_deepslate_wall": {
        lang: "tile.cobbled_deepslate_wall.name",
    },
    "minecraft:deepslate_tile_wall": {
        lang: "tile.deepslate_tile_wall.name",
    },
    "minecraft:polished_deepslate_wall": {
        lang: "tile.polished_deepslate_wall.name",
    },
    "minecraft:deepslate_brick_wall": {
        lang: "tile.deepslate_brick_wall.name",
    },
    "minecraft:mud_brick_wall": {
        lang: "tile.mud_brick_wall.name",
    },
    "minecraft:oak_fence": {
        lang: "tile.fence.name",
    },
    "minecraft:spruce_fence": {
        lang: "tile.spruceFence.name",
    },
    "minecraft:birch_fence": {
        lang: "tile.birchFence.name",
    },
    "minecraft:jungle_fence": {
        lang: "tile.jungleFence.name",
    },
    "minecraft:acacia_fence": {
        lang: "tile.acaciaFence.name",
    },
    "minecraft:dark_oak_fence": {
        lang: "tile.darkOakFence.name",
    },
    "minecraft:mangrove_fence": {
        lang: "tile.mangrove_fence.name",
    },
    "minecraft:cherry_fence": {
        lang: "tile.cherry_fence.name",
    },
    "minecraft:bamboo_fence": {
        lang: "tile.bamboo_fence.name",
    },
    "minecraft:nether_brick_fence": {
        lang: "tile.nether_brick_fence.name",
    },
    "minecraft:crimson_fence": {
        lang: "tile.crimson_fence.name",
    },
    "minecraft:warped_fence": {
        lang: "tile.warped_fence.name",
    },
    "minecraft:fence_gate": {
        lang: "tile.fence_gate.name",
    },
    "minecraft:spruce_fence_gate": {
        lang: "tile.spruce_fence_gate.name",
    },
    "minecraft:birch_fence_gate": {
        lang: "tile.birch_fence_gate.name",
    },
    "minecraft:jungle_fence_gate": {
        lang: "tile.jungle_fence_gate.name",
    },
    "minecraft:acacia_fence_gate": {
        lang: "tile.acacia_fence_gate.name",
    },
    "minecraft:dark_oak_fence_gate": {
        lang: "tile.dark_oak_fence_gate.name",
    },
    "minecraft:mangrove_fence_gate": {
        lang: "tile.mangrove_fence_gate.name",
    },
    "minecraft:cherry_fence_gate": {
        lang: "tile.cherry_fence_gate.name",
    },
    "minecraft:bamboo_fence_gate": {
        lang: "tile.bamboo_fence_gate.name",
    },
    "minecraft:crimson_fence_gate": {
        lang: "tile.crimson_fence_gate.name",
    },
    "minecraft:warped_fence_gate": {
        lang: "tile.warped_fence_gate.name",
    },
    //! STAIRS
    "minecraft:wooden_door": {
        lang: "item.wooden_door.name",
    },
    "minecraft:spruce_door": {
        lang: "item.spruce_door.name",
    },
    "minecraft:birch_door": {
        lang: "item.birch_door.name",
    },
    "minecraft:jungle_door": {
        lang: "item.jungle_door.name",
    },
    "minecraft:acacia_door": {
        lang: "item.acacia_door.name",
    },
    "minecraft:dark_oak_door": {
        lang: "item.dark_oak_door.name",
    },
    "minecraft:mangrove_door": {
        lang: "item.mangrove_door.name",
    },
    "minecraft:cherry_door": {
        lang: "item.cherry_door.name",
    },
    "minecraft:bamboo_door": {
        lang: "item.bamboo_door.name",
    },
    "minecraft:iron_door": {
        lang: "item.iron_door.name",
    },
    "minecraft:crimson_door": {
        lang: "item.crimson_door.name",
    },
    "minecraft:warped_door": {
        lang: "item.warped_door.name",
    },
    //! Wool
    "minecraft:white_wool": {
        lang: "tile.wool.white.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:light_gray_wool": {
        lang: "tile.wool.Silver.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:gray_wool": {
        lang: "tile.wool.Gray.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:black_wool": {
        lang: "tile.wool.Black.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:brown_wool": {
        lang: "tile.wool.Brown.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:red_wool": {
        lang: "tile.wool.Red.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:orange_wool": {
        lang: "tile.wool.Orange.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:yellow_wool": {
        lang: "tile.wool.Yellow.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:lime_wool": {
        lang: "tile.wool.Lime.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:green_wool": {
        lang: "tile.wool.Green.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:cyan_wool": {
        lang: "tile.wool.Cyan.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:light_blue_wool": {
        lang: "tile.wool.LightBlue.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:blue_wool": {
        lang: "tile.wool.Blue.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:purple_wool": {
        lang: "tile.wool.Purple.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:magenta_wool": {
        lang: "tile.wool.Magenta.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:pink_wool": {
        lang: "tile.wool.Pink.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    //! Carpet
    "minecraft:white_carpet": {
        lang: "tile.carpet.white.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:light_gray_carpet": {
        lang: "tile.carpet.Silver.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:gray_carpet": {
        lang: "tile.carpet.Gray.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:black_carpet": {
        lang: "tile.carpet.Black.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:brown_carpet": {
        lang: "tile.carpet.Brown.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:red_carpet": {
        lang: "tile.carpet.Red.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:orange_carpet": {
        lang: "tile.carpet.Orange.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:yellow_carpet": {
        lang: "tile.carpet.Yellow.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:lime_carpet": {
        lang: "tile.carpet.Lime.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:green_carpet": {
        lang: "tile.carpet.Green.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:cyan_carpet": {
        lang: "tile.carpet.Cyan.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:light_blue_carpet": {
        lang: "tile.carpet.LightBlue.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:blue_carpet": {
        lang: "tile.carpet.Blue.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:purple_carpet": {
        lang: "tile.carpet.Purple.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:magenta_carpet": {
        lang: "tile.carpet.Magenta.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:pink_carpet": {
        lang: "tile.carpet.Pink.name",
        tool: {
            type: "shears",
            level: undefined
        }
    },
    "minecraft:crafting_table": {
        lang: "tile.crafting_table.name",
    },
    "minecraft:cartography_table": {
        lang: "tile.cartography_table.name",
    },
    "minecraft:fletching_table": {
        lang: "tile.fletching_table.name",
    },
    "minecraft:smithing_table": {
        lang: "tile.smithing_table.name",
    },
    "minecraft:beehive": {
        lang: "tile.beehive.name",
    },
    "minecraft:frame": {
        lang: "item.frame.name",
    },
    //! Skull
    "minecraft:player_head": {
        lang: "item.skull.char.name",
    },
    "minecraft:zombie_head": {
        lang: "item.skull.zombie.name",
    },
    "minecraft:creeper_head": {
        lang: "item.skull.creeper.name",
    },
    "minecraft:dragon_head": {
        lang: "item.skull.dragon.name",
    },
    "minecraft:skeleton_skull": {
        lang: "item.skull.skeleton.name",
    },
    "minecraft:wither_skeleton_skull": {
        lang: "item.skull.wither.name",
    },
    "minecraft:piglin_head": {
        lang: "item.skull.piglin.name",
    },
    "minecraft:grass_block": {
        lang: "tile.grass.name",
    },
    "minecraft:podzol": {
        lang: "tile.podzol.name",
    },
    "minecraft:mycelium": {
        lang: "tile.mycelium.name",
    },
    "minecraft:grass_path": {
        lang: "tile.grass_path.name",
    },
    "minecraft:dirt": {
        lang: "tile.dirt.name",
    },
    "minecraft:coarse_dirt": {
        lang: "tile.dirt.coarse.name",
    },
    "minecraft:dirt_with_roots": {
        lang: "tile.dirt_with_roots.name",
    },
    "minecraft:farmland": {
        lang: "tile.farmland.name",
    },
    "minecraft:clay": {
        lang: "tile.clay.name",
    },
    "minecraft:stone": {
        lang: "tile.stone.stone.name",
    },
    "minecraft:granite": {
        lang: "tile.stone.granite.name",
    },
    "minecraft:diorite": {
        lang: "tile.stone.diorite.name",
    },
    "minecraft:andesite": {
        lang: "tile.stone.andesite.name",
    },
    "minecraft:blackstone": {
        lang: "tile.blackstone.name",
    },
    "minecraft:deepslate": {
        lang: "tile.deepslate.name",
    },
    "minecraft:tuff": {
        lang: "tile.tuff.name",
    },
    "minecraft:basalt": {
        lang: "tile.basalt.name",
    },
    "minecraft:polished_granite": {
        lang: "tile.stone.graniteSmooth.name",
    },
    "minecraft:polished_diorite": {
        lang: "tile.stone.dioriteSmooth.name",
    },
    "minecraft:polished_andesite": {
        lang: "tile.stone.andesiteSmooth.name",
    },
    "minecraft:polished_blackstone": {
        lang: "tile.polished_blackstone.name",
    },
    "minecraft:polished_deepslate": {
        lang: "tile.polished_deepslate.name",
    },
    "minecraft:polished_tuff": {
        lang: "tile.polished_tuff.name",
    },
    "minecraft:polished_basalt": {
        lang: "tile.polished_basalt.name",
    },
    "minecraft:smooth_basalt": {
        lang: "tile.smooth_basalt.name",
    },
    "minecraft:gravel": {
        lang: "tile.gravel.name",
    },
    "minecraft:sand": {
        lang: "tile.sand.name",
    },
    "minecraft:oak_log": {
        lang: "tile.log.oak.name",
    },
    "minecraft:stripped_oak_log": {
        lang: "tile.stripped_oak_log.name",
    },
    "minecraft:spruce_log": {
        lang: "tile.log.spruce.name",
    },
    "minecraft:stripped_spruce_log": {
        lang: "tile.stripped_spruce_log.name",
    },
    "minecraft:birch_log": {
        lang: "tile.log.birch.name",
    },
    "minecraft:stripped_birch_log": {
        lang: "tile.stripped_birch_log.name",
    },
    "minecraft:jungle_log": {
        lang: "tile.log.jungle.name",
    },
    "minecraft:stripped_jungle_log": {
        lang: "tile.stripped_jungle_log.name",
    },
    "minecraft:acacia_log": {
        lang: "tile.log.acacia.name",
    },
    "minecraft:stripped_acacia_log": {
        lang: "tile.stripped_acacia_log.name",
    },
    "minecraft:dark_oak_log": {
        lang: "tile.log.big_oak.name",
    },
    "minecraft:stripped_dark_oak_log": {
        lang: "tile.stripped_dark_oak_log.name",
    },
    "minecraft:mangrove_log": {
        lang: "tile.mangrove_log.name",
    },
    "minecraft:stripped_mangrove_log": {
        lang: "tile.stripped_mangrove_log.name",
    },
    "minecraft:cherry_log": {
        lang: "tile.cherry_log.name",
    },
    "minecraft:stripped_cherry_log": {
        lang: "tile.stripped_cherry_log.name",
    },
    "minecraft:crimson_stem": {
        lang: "tile.crimson_stem.name",
    },
    "minecraft:stripped_crimson_stem": {
        lang: "tile.stripped_crimson_stem.name",
    },
    "minecraft:warped_stem": {
        lang: "tile.warped_stem.name",
    },
    "minecraft:stripped_warped_stem": {
        lang: "tile.stripped_warped_stem.name",
    },
    "minecraft:oak_leaves": {
        lang: "tile.leaves.oak.name",
    },
    "minecraft:spruce_leaves": {
        lang: "tile.leaves.spruce.name",
    },
    "minecraft:birch_leaves": {
        lang: "tile.leaves.birch.name",
    },
    "minecraft:jungle_leaves": {
        lang: "tile.leaves.jungle.name",
    },
    "minecraft:acacia_leaves": {
        lang: "tile.leaves.acacia.name",
    },
    "minecraft:dark_oak_leaves": {
        lang: "tile.leaves.big_oak.name",
    },
    "minecraft:mangrove_leaves": {
        lang: "tile.mangrove_leaves.name",
    },
    "minecraft:cherry_leaves": {
        lang: "tile.cherry_leaves.name",
    },
    "minecraft:azalea_leaves": {
        lang: "tile.azalea_leaves.name",
    },
    "minecraft:azalea_leaves_flowered": {
        lang: "tile.azalea_leaves_flowered.name",
    },
    "minecraft:fern": {
        lang: "tile.tallgrass.fern.name",
    },
    "minecraft:large_fern": {
        lang: "tile.double_plant.fern.name",
    },
    "minecraft:short_grass": {
        lang: "tile.grass.name",
    },
    "minecraft:tall_grass": {
        lang: "tile.double_plant.grass.name",
    },
    "minecraft:nether_sprouts": {
        lang: "tile.nether_sprouts.name",
    },
    //! Flowers
    "minecraft:crimson_roots": {
        lang: "tile.crimson_roots.crimsonRoots.name",
    },
    "minecraft:warped_roots": {
        lang: "tile.warped_roots.warpedRoots.name",
    },
    "minecraft:dandelion": {
        lang: "tile.yellow_flower.dandelion.name",
    },
    "minecraft:poppy": {
        lang: "tile.red_flower.poppy.name",
    },
    "minecraft:blue_orchid": {
        lang: "tile.red_flower.blueOrchid.name",
    },
    "minecraft:allium": {
        lang: "tile.red_flower.allium.name",
    },
    "minecraft:azure_bluet": {
        lang: "tile.red_flower.houstonia.name",
    },
    "minecraft:red_tulip": {
        lang: "tile.red_flower.tulipRed.name",
    },
    "minecraft:orange_tulip": {
        lang: "tile.red_flower.tulipOrange.name",
    },
    "minecraft:white_tulip": {
        lang: "tile.red_flower.tulipWhite.name",
    },
    "minecraft:pink_tulip": {
        lang: "tile.red_flower.tulipPink.name",
    },
    "minecraft:oxeye_daisy": {
        lang: "tile.red_flower.oxeyeDaisy.name",
    },
    "minecraft:cornflower": {
        lang: "tile.red_flower.cornflower.name",
    },
    "minecraft:lily_of_the_valley": {
        lang: "tile.red_flower.lilyOfTheValley.name",
    },
    "minecraft:sunflower": {
        lang: "tile.double_plant.sunflower.name",
    },
    "minecraft:lilac": {
        lang: "tile.double_plant.syringa.name",
    },
    "minecraft:rose_bush": {
        lang: "tile.double_plant.rose.name",
    },
    "minecraft:peony": {
        lang: "tile.double_plant.paeonia.name",
    },
    "minecraft:pitcher_plant": {
        lang: "tile.pitcher_plant.name",
    },
    "minecraft:pink_petals": {
        lang: "tile.pink_petals.name",
    },
    "minecraft:wither_rose": {
        lang: "tile.wither_rose.name",
    },
    "minecraft:torchflower": {
        lang: "tile.torchflower.name",
    },
    "minecraft:closed_eyeblossom": {
        lang: "tile.closed_eyeblossom.name",
    },
    "minecraft:open_eyeblossom": {
        lang: "tile.open_eyeblossom.name",
    },
    "minecraft:seagrass": {
        lang: "tile.seagrass.seagrass.name",
    },
    //! Shulker
    "minecraft:undyed_shulker_box": {
        lang: "tile.shulkerBox.name",
    },
    "minecraft:white_shulker_box": {
        lang: "tile.shulkerBoxWhite.name",
    },
    "minecraft:light_gray_shulker_box": {
        lang: "tile.shulkerBoxSilver.name",
    },
    "minecraft:gray_shulker_box": {
        lang: "tile.shulkerBoxGray.name",
    },
    "minecraft:black_shulker_box": {
        lang: "tile.shulkerBoxBlack.name",
    },
    "minecraft:brown_shulker_box": {
        lang: "tile.shulkerBoxBrown.name",
    },
    "minecraft:red_shulker_box": {
        lang: "tile.shulkerBoxRed.name",
    },
    "minecraft:orange_shulker_box": {
        lang: "tile.shulkerBoxOrange.name",
    },
    "minecraft:yellow_shulker_box": {
        lang: "tile.shulkerBoxYellow.name",
    },
    "minecraft:lime_shulker_box": {
        lang: "tile.shulkerBoxLime.name",
    },
    "minecraft:green_shulker_box": {
        lang: "tile.shulkerBoxGreen.name",
    },
    "minecraft:cyan_shulker_box": {
        lang: "tile.shulkerBoxCyan.name",
    },
    "minecraft:light_blue_shulker_box": {
        lang: "tile.shulkerBoxLightBlue.name",
    },
    "minecraft:blue_shulker_box": {
        lang: "tile.shulkerBoxBlue.name",
    },
    "minecraft:purple_shulker_box": {
        lang: "tile.shulkerBoxPurple.name",
    },
    "minecraft:magenta_shulker_box": {
        lang: "tile.shulkerBoxMagenta.name",
    },
    "minecraft:pink_shulker_box": {
        lang: "tile.shulkerBoxPink.name",
    },
    "minecraft:anvil": {
        lang: "tile.anvil.name",
    },
    "minecraft:chipped_anvil": {
        lang: "tile.anvil.slightlyDamaged.name",
    },
    "minecraft:damaged_anvil": {
        lang: "tile.anvil.veryDamaged.name",
    },
    //! Redstone
    "minecraft:redstone_ore": {
        lang: "tile.redstone_ore.name",
    },
    "minecraft:lit_redstone_ore": {
        lang: "tile.redstone_ore.name",
    },
    "minecraft:deepslate_redstone_ore": {
        lang: "tile.deepslate_redstone_ore.name",
    },
    "minecraft:lit_deepslate_redstone_ore": {
        lang: "tile.deepslate_redstone_ore.name",
    },
    "minecraft:redstone_lamp": {
        lang: "tile.redstone_lamp.name",
    },
    "minecraft:lit_redstone_lamp": {
        lang: "tile.redstone_lamp.name",
    },
    "minecraft:redstone_block": {
        lang: "tile.redstone_block.name",
    },
    "minecraft:redstone_torch": {
        lang: "tile.redstone_torch.name",
    },
    "minecraft:powered_repeater": {
        lang: "item.repeater.name",
    },
    "minecraft:unpowered_repeater": {
        lang: "item.repeater.name",
    },
    "minecraft:powered_comparator": {
        lang: "item.comparator.name",
    },
    "minecraft:unpowered_comparator": {
        lang: "item.comparator.name",
    },
};
export function getValidValues(block, keysToCheck) {
    const allValues = {};
    keysToCheck.forEach((key) => {
        const validValues = BlockStates.get(key)?.validValues;
        if (validValues) {
            allValues[key] = validValues;
        }
    });
    for (const key of keysToCheck) {
        const currentValue = block.permutation.getState(key);
        const values = allValues[key];
        if (currentValue !== undefined && values) {
            return { current: currentValue, last: values[values.length - 1] };
        }
    }
    return undefined;
}
export function processInventory(block, player, titleRaw) {
    const inv = block.getComponent("inventory")?.container;
    if (!inv)
        return titleRaw;
    let slots = 0;
    let itemsString = "";
    for (let i = 0; i < inv.size; i++) {
        const item = inv.getItem(i);
        if (item) {
            slots++;
            if (player.isSneaking) {
                const clearItem = clear(`${item.typeId.split(":")[1]}, `);
                itemsString += clearItem;
            }
        }
    }
    titleRaw += `\n§7Container: ${slots}/${inv.size}`;
    if (player.isSneaking && slots) {
        let formattedItems = itemsString.replace(/,(?=[^,]*$)/, ".");
        if (formattedItems.length >= 20)
            formattedItems = formattedItems.slice(0, 19) + "...";
        titleRaw += `\n§7Items: ${formattedItems}`;
    }
    return titleRaw;
}
export function getToolIcon(block) {
    const tags = block.getTags();
    const tagToToolMap = {
        "minecraft:is_mace_item_destructible": "mace",
        "minecraft:is_shovel_item_destructible": "shovel",
        "minecraft:is_shears_item_destructible": "shears",
        "minecraft:is_sword_item_destructible": "sword",
        "minecraft:is_tool_item_destructible": "generic_tool",
        "minecraft:is_axe_item_destructible": "axe",
        "minecraft:is_digger_item_destructible": "digger",
        "minecraft:is_pickaxe_item_destructible": "pickaxe",
        "minecraft:is_hoe_item_destructible": "hoe"
    };
    const tagToLevelMap = {
        "minecraft:wood_tier_destructible": 1,
        "minecraft:stone_tier_destructible": 2,
        "minecraft:iron_tier_destructible": 3,
        "minecraft:diamond_tier_destructible": 4,
        "minecraft:netherite_tier_destructible": 5
    };
    const iconMap = {
        sword: { 1: "", 2: "", 3: "", 4: "", 5: "" },
        pickaxe: { 1: "", 2: "", 3: "", 4: "", 5: "" },
        axe: { 1: "", 2: "", 3: "", 4: "", 5: "" },
        shovel: { 1: "", 2: "", 3: "", 4: "", 5: "" },
        hoe: { 1: "", 2: "", 3: "", 4: "", 5: "" },
        shears: ""
    };
    const findMatch = (tags, map) => tags.find(tag => map[tag]);
    let tool = tagToToolMap[findMatch(tags, tagToToolMap)];
    let toolLevel = tagToLevelMap[findMatch(tags, tagToLevelMap)];
    if (tool && toolLevel === undefined) {
        toolLevel = 1;
    }
    const getIcon = (tool, level) => {
        if (tool === "shears")
            return iconMap.shears;
        return iconMap[tool]?.[level];
    };
    let icon = getIcon(tool, toolLevel);
    if (!icon) {
        const data = blocks[block.typeId]?.tool;
        tool = data?.type;
        toolLevel = data?.level;
        icon = getIcon(tool, toolLevel);
    }
    return icon;
}
